/*
2007-11-12 9:48
 ģ

עƵԼѡ
*/


module send_test(clk,switch,key_in, TxD, TxD_busy,TxD_en,TxD_start);
input clk, TxD_en,TxD_start;
input	[3:0]switch;
output TxD, TxD_busy;


// ʹ  ϵͳʱ
`ifdef  DEBUG_SIMULATION	
	parameter ClkFrequency = 50_000;	
`else
	parameter ClkFrequency = 50_000_000;	// 50MHz
`endif

parameter Baud = 9600;
parameter RegisterInputData = 1;	


integer		count_temp;


// Baud generator
parameter BaudGeneratorAccWidth = 16;
reg [BaudGeneratorAccWidth:0] BaudGeneratorAcc;
`ifdef DEBUG
wire [BaudGeneratorAccWidth:0] BaudGeneratorInc = 17'h10000;
`else
wire [BaudGeneratorAccWidth:0] BaudGeneratorInc = ((Baud<<(BaudGeneratorAccWidth-4))+(ClkFrequency>>5))/(ClkFrequency>>4);
`endif

wire BaudTick = BaudGeneratorAcc[BaudGeneratorAccWidth];
wire TxD_busy;
always @(posedge clk) if(TxD_busy) BaudGeneratorAcc <= BaudGeneratorAcc[BaudGeneratorAccWidth-1:0] + BaudGeneratorInc;

// Transmitter state machine
reg [3:0] state;
wire TxD_ready = (state==0);
assign TxD_busy = ~TxD_ready;

parameter KEY_WIDTH = 1;					//

input[KEY_WIDTH-1:0] key_in;				//ⲿ

reg[KEY_WIDTH-1:0]dout1,dout2,dout3,buff;		//Ĵ		
reg div_clk;							//Ƶʱ
reg[16:0]count;							//ʱӷƵ


//ʱӷƵ
always @(posedge clk)
begin
	if (count < 17'd120000)
	begin
 	    count <= count + 1'b1;
 	    div_clk <= 1'b0;
 	end
 	else
 	begin
 	    count <= 17'd0;
 	    div_clk <= 1'b1;
 	end
end

//
always @(posedge clk)
begin
	if(div_clk)
	begin
		dout1 <= key_in;
		dout2 <= dout1;
		dout3 <= dout2;
	end	
end

//ؼⲿ
always @(posedge clk)
begin
	buff <= dout1 | dout2 | dout3;
end

wire key_edge_out;

assign key_edge_out = ~(dout1 | dout2 | dout3) & buff;

	
always @(posedge clk)
case(state)
	//4'b0000: if(key_edge_out) state <= 4'b0001;
	4'b0000:  state <= 4'b0001;
	4'b0001: if(BaudTick) state <= 4'b0100;
	4'b0100: if(BaudTick) state <= 4'b1000;  // start
	4'b1000: if(BaudTick) state <= 4'b1001;  // bit 0
	4'b1001: if(BaudTick) state <= 4'b1010;  // bit 1
	4'b1010: if(BaudTick) state <= 4'b1011;  // bit 2
	4'b1011: if(BaudTick) state <= 4'b1100;  // bit 3
	4'b1100: if(BaudTick) state <= 4'b1101;  // bit 4
	4'b1101: if(BaudTick) state <= 4'b1110;  // bit 5
	4'b1110: if(BaudTick) state <= 4'b1111;  // bit 6
	4'b1111: if(BaudTick) state <= 4'b0010;  // bit 7
	4'b0010: if(BaudTick) state <= 4'b0011;  // stop1
	4'b0011: if(BaudTick) state <= 4'b0000;  // stop2
	default: if(BaudTick) state <= 4'b0000;
endcase

// Output mux
reg muxbit;
always @( state[2:0] )
case(state[2:0])
	
//  ͹̶ 7
	3'd0: muxbit <= 1;
	3'd1: muxbit <= 1;
	3'd2: muxbit <= 1;
	3'd3: muxbit <= 0;
	3'd4: muxbit <= 1;
	3'd5: muxbit <= 1;
	3'd6: muxbit <= 0;
	3'd7: muxbit <= 0;

	
endcase


// Put together the start, data and stop bits
reg TxD_buf;

always @(posedge clk) 
	TxD_buf <= (state<4) | (state[3] & muxbit) ;  

assign	TxD  = TxD_buf;

endmodule
