# Copyright (C) 1991-2008 Altera Corporation
# Your use of Altera Corporation's design tools, logic functions 
# and other software and tools, and its AMPP partner logic 
# functions, and any output files from any of the foregoing 
# (including device programming or simulation files), and any 
# associated documentation or information are expressly subject 
# to the terms and conditions of the Altera Program License 
# Subscription Agreement, Altera MegaCore Function License 
# Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by 
# Altera or its authorized distributors.  Please refer to the 
# applicable agreement for further details.

# Quartus II: Generate Tcl File for Project
# File: div.tcl
# Generated on: Wed Aug 05 11:21:42 2009

# Load Quartus II Tcl Project package
package require ::quartus::project

set need_to_close_project 0
set make_assignments 1

# Check that the right project is open
if {[is_project_open]} {
	if {[string compare $quartus(project) "div"]} {
		puts "Project div is not open"
		set make_assignments 0
	}
} else {
	# Only open if not already open
	if {[project_exists div]} {
		project_open -revision div div
	} else {
		project_new -revision div div
	}
	set need_to_close_project 1
}

# Make assignments
if {$make_assignments} {
	set_global_assignment -name INCREMENTAL_COMPILATION OFF
	set_global_assignment -name ORIGINAL_QUARTUS_VERSION 7.0
	set_global_assignment -name PROJECT_CREATION_TIME_DATE "19:28:07  SEPTEMBER 03, 2007"
	set_global_assignment -name LAST_QUARTUS_VERSION 8.1
	set_global_assignment -name VERILOG_FILE div.v
	set_global_assignment -name VECTOR_WAVEFORM_FILE div.vwf
	set_global_assignment -name CDF_FILE Chain1.cdf
	set_global_assignment -name FAMILY "Cyclone II"
	set_global_assignment -name DEVICE EP2C8Q208C8
	set_global_assignment -name RESERVE_ALL_UNUSED_PINS "AS INPUT TRI-STATED"
	set_global_assignment -name RESERVE_ASDO_AFTER_CONFIGURATION "AS INPUT TRI-STATED"
	set_global_assignment -name FITTER_EFFORT "STANDARD FIT"
	set_global_assignment -name ERROR_CHECK_FREQUENCY_DIVISOR 1
	set_global_assignment -name ON_CHIP_BITSTREAM_DECOMPRESSION ON
	set_global_assignment -name STRATIX_CONFIGURATION_DEVICE EPCS4
	set_global_assignment -name PARTITION_NETLIST_TYPE SOURCE -section_id Top
	set_global_assignment -name LL_ROOT_REGION ON -section_id "Root Region"
	set_global_assignment -name LL_MEMBER_STATE LOCKED -section_id "Root Region"
	set_global_assignment -name USE_CONFIGURATION_DEVICE ON
	set_global_assignment -name MISC_FILE "E:/guangpan/FPGA-NIOS//EP2C5-8NIOS/EP2C5/EP2C5Q208_DIV_led/div.dpf"
	set_global_assignment -name RESERVE_ALL_UNUSED_PINS_NO_OUTPUT_GND "AS INPUT TRI-STATED"
	set_global_assignment -name STRATIX_DEVICE_IO_STANDARD "3.3-V LVTTL"
	set_location_assignment PIN_23 -to clk
	set_location_assignment PIN_8 -to leda[4]
	set_location_assignment PIN_6 -to leda[5]
	set_instance_assignment -name PARTITION_HIERARCHY no_file_for_top_partition -to | -section_id Top
	set_location_assignment PIN_5 -to leda[0]
	set_location_assignment PIN_10 -to leda[1]
	set_location_assignment PIN_37 -to leda[6]
	set_location_assignment PIN_39 -to leda[7]
	set_location_assignment PIN_40 -to leda[8]
	set_location_assignment PIN_47 -to leda[9]
	set_location_assignment PIN_67 -to leda[10]
	set_location_assignment PIN_68 -to leda[11]
	set_location_assignment PIN_69 -to leda[12]
	set_location_assignment PIN_70 -to leda[13]
	set_location_assignment PIN_72 -to leda[14]
	set_location_assignment PIN_74 -to leda[15]
	set_location_assignment PIN_141 -to leda[16]
	set_location_assignment PIN_139 -to leda[17]
	set_location_assignment PIN_138 -to leda[18]
	set_location_assignment PIN_137 -to leda[19]

	# Commit assignments
	export_assignments

	# Close project
	if {$need_to_close_project} {
		project_close
	}
}
